VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsMJAutomation"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public m_lblUI              As Label

Private Declare Function GetTickCount Lib "kernel32" () As Long

Const VERSION_ID = 1
Const REPLACE_CRLF = "~|_=~"

Dim m_MapFile               As New CMapFile
Dim m_MapFileTemp           As New CMapFile

Dim m_bOpened               As Boolean

Dim m_szFilename            As String
Dim m_lNumFiles             As Long
Dim m_Files                 As New Collection
Dim m_szBigString           As String * 16384

Public Function Search(szCriteria As String) As Object

    '  Read the data
    If m_Files.Count = 0 Then
        EmulationRead
    End If
    
    '  Get a new entry
    Set Search = New clsMJFiles
    
    '  Point to the data
    Set Search.m_Files = m_Files
    
End Function

Public Function GetCurPlayList() As Object

    '  Get a new entry
    Set GetCurPlayList = New clsMJFiles
    
    '  Point to the data
    Set GetCurPlayList.m_Files = m_Files
    
End Function

Public Function GetVersion() As Object
    Set GetVersion = New clsMJVersion
End Function

Public Sub EmulationDump(MJAutomation As MJAutomation, Optional szCriteria As String = "", Optional bExcludeSlowItems As Boolean = False)
Dim dStart          As Double
Dim dStop           As Double

    dStart = GetTickCount()
    EmulationWrite MJAutomation.Search(szCriteria), bExcludeSlowItems
    dStop = GetTickCount()
    
    If Not m_lblUI Is Nothing Then
        m_lblUI.Caption = ""
        m_lblUI.Refresh
    End If
    
    MsgBox "Dumped " & m_lNumFiles & " MJFile's in " & ((dStop - dStart) / 1000) & " seconds"
    
End Sub

Public Sub EmulationWrite(MJFiles As MJFilesAutomation, Optional bExcludeSlowItems As Boolean = False)
Dim lLoop1          As Long
Dim MJFile          As MJFileAutomation

    On Error Resume Next
    
    '  Open the file
    If EmulationOpen(True) Then
    
        '  Write out the version number
        m_MapFileTemp.PutLngEx VERSION_ID
        
        '  Write out the number of files
        m_lNumFiles = MJFiles.GetNumberFiles
        lLoop1 = m_lNumFiles
        
        m_MapFileTemp.PutLngEx lLoop1
        
        '  Dump them
        While lLoop1 > 0
            
            If Not m_lblUI Is Nothing Then
                m_lblUI.Caption = CStr(lLoop1)
                m_lblUI.Refresh
            End If
            
            lLoop1 = lLoop1 - 1
            EmulationWriteEntry lLoop1, MJFiles.GetFile(lLoop1), bExcludeSlowItems
        
        Wend
        
        '  Close the file
        EmulationClose True
    
    End If
    
End Sub

Public Sub EmulationRead()
Dim lVersionId          As Long

    '  Open the file
    If EmulationOpen(False) Then
    
        '  Read the version
        lVersionId = m_MapFile.GetLngEx()
        If lVersionId = VERSION_ID Then
        
            '  Read in the number of records
            m_lNumFiles = m_MapFile.GetLngEx()
            
            '  Read the data
            While m_lNumFiles > 0
            
                If Not m_lblUI Is Nothing Then
                    m_lblUI.Caption = CStr(m_lNumFiles)
                    m_lblUI.Refresh
                End If
                
                m_Files.Add EmulationReadEntry
                m_lNumFiles = m_lNumFiles - 1
                
                '  Be nice to Windows
                DoEvents
                
            Wend
        
            m_lNumFiles = m_Files.Count
            
        Else
        
            MsgBox "Invalid file version, found " & lVersionId & " expected " & VERSION_ID & "!", vbExclamation + vbOKOnly
            
        End If
    
        '  Close the file
        EmulationClose False
        
    End If
    
End Sub


Private Function EmulationReadEntry() As clsMJFile
Dim MJFile      As New clsMJFile

    With MJFile
    
        .ImageDatabase = m_MapFile.GetStrEx
        .GetFormattedFileSize = m_MapFile.GetStrEx
        .GetFormattedFileDate = m_MapFile.GetStrEx
        .GetFormattedDuration = m_MapFile.GetStrEx
        .GetFormattedLastPlayed = m_MapFile.GetStrEx
        .FileName = m_MapFile.GetStrEx
        .Artist = m_MapFile.GetStrEx
        .Album = m_MapFile.GetStrEx
        .Name = m_MapFile.GetStrEx
        .Genre = m_MapFile.GetStrEx
        .Comment = m_MapFile.GetStrEx
        .Custom1 = m_MapFile.GetStrEx
        .Custom2 = m_MapFile.GetStrEx
        .Custom3 = m_MapFile.GetStrEx
        .Filetype = m_MapFile.GetStrEx
    
        .Filesize = m_MapFile.GetLngEx
        .Duration = m_MapFile.GetLngEx
        .Year = m_MapFile.GetLngEx
        .Bitrate = m_MapFile.GetLngEx
        .Tracknumber = m_MapFile.GetLngEx
        .Filedate = m_MapFile.GetLngEx
        .PlayCounter = m_MapFile.GetLngEx
        .LastPlayed = m_MapFile.GetLngEx
        .Rating = m_MapFile.GetLngEx
        
        '  Slow items
        .Lyrics = m_MapFile.GetStrEx
        .Notes = m_MapFile.GetStrEx
    
    End With
    
    Set EmulationReadEntry = MJFile
    
End Function

Private Sub EmulationWriteEntry(lIndex As Long, MJFile As MJFileAutomation, Optional bExcludeSlowItems As Boolean = False)

    With MJFile
    
        m_MapFileTemp.PutStrEx .GetImageFile(IMAGEFILE_IN_DATABASE)
        m_MapFileTemp.PutStrEx .GetFormattedFileSize
        m_MapFileTemp.PutStrEx .GetFormattedFileDate
        m_MapFileTemp.PutStrEx .GetFormattedDuration
        m_MapFileTemp.PutStrEx .GetFormattedLastPlayed
        m_MapFileTemp.PutStrEx .FileName
        m_MapFileTemp.PutStrEx .Artist
        m_MapFileTemp.PutStrEx .Album
        m_MapFileTemp.PutStrEx .Name
        m_MapFileTemp.PutStrEx .Genre
        m_MapFileTemp.PutStrEx .Comment
        m_MapFileTemp.PutStrEx .Custom1
        m_MapFileTemp.PutStrEx .Custom2
        m_MapFileTemp.PutStrEx .Custom3
        m_MapFileTemp.PutStrEx .Filetype
        
        m_MapFileTemp.PutLngEx .Filesize
        m_MapFileTemp.PutLngEx .Duration
        m_MapFileTemp.PutLngEx .Year
        m_MapFileTemp.PutLngEx .Bitrate
        m_MapFileTemp.PutLngEx .Tracknumber
        m_MapFileTemp.PutLngEx .Filedate
        m_MapFileTemp.PutLngEx .PlayCounter
        m_MapFileTemp.PutLngEx .LastPlayed
        m_MapFileTemp.PutLngEx .Rating
    
        '  Slow items
        If bExcludeSlowItems Then
            m_MapFileTemp.PutStrEx "(Lyrics Excluded - Slow Item)"
            m_MapFileTemp.PutStrEx "(Notes Excluded - Slow Item)"
        Else
            m_MapFileTemp.PutStrEx .Lyrics
            m_MapFileTemp.PutStrEx .Notes
        End If
        
    End With
    
End Sub

Private Function EmulationOpen(ByVal bWrite As Boolean) As Boolean
Dim szFilename          As String

    On Error Resume Next
    
    '  Open as mapped
    If bWrite Then
        m_bOpened = m_MapFileTemp.MapFileTemp(&H7FFFFFF)
    Else
        m_bOpened = m_MapFile.MapFile(m_szFilename)
    End If
    
    '  An error?
    If Not m_bOpened Then
        MsgBox "Could not open the emulation file!"
    End If
    
    '  Return the status
    EmulationOpen = m_bOpened
    
End Function

Private Sub EmulationClose(ByVal bWrite As Boolean)

    With m_MapFile
    
        If m_bOpened Then
        
            If bWrite Then
            
                '  Open the true file
                .MapFileNew m_szFilename, m_MapFileTemp.Offset
                
                '  Copy the data
                .CopyMapData m_MapFileTemp
                
                '  Close the temp
                m_MapFileTemp.UnMapFile
                
            End If
            
            '  Close the file
            .UnMapFile
            
        End If
        
    End With
    
    
End Sub


Private Sub Class_Initialize()

    '  Build the filename
    m_szFilename = App.Path & "\MJEmulation.dat"

End Sub
