VERSION 5.00
Begin VB.UserControl Interface 
   ClientHeight    =   4320
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   6240
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ScaleHeight     =   4320
   ScaleWidth      =   6240
   Begin VB.CheckBox chkExcludeSlowItems 
      Caption         =   "Exclude Slow Items (e.g. Lyrics/Notes)"
      Height          =   375
      Left            =   2730
      TabIndex        =   3
      Top             =   840
      Value           =   1  'Checked
      Width           =   3345
   End
   Begin VB.CommandButton btnDumpToScreen 
      Caption         =   "Dump To Screen"
      Height          =   585
      Left            =   330
      TabIndex        =   4
      Top             =   2040
      Width           =   2295
   End
   Begin VB.ListBox lbxDump 
      Height          =   1425
      Left            =   330
      TabIndex        =   5
      Top             =   2640
      Width           =   5085
   End
   Begin VB.TextBox txtCriteria 
      Height          =   315
      Left            =   1590
      TabIndex        =   1
      Top             =   510
      Width           =   4155
   End
   Begin VB.CommandButton btnDumpToFile 
      Caption         =   "Dump To File"
      Height          =   585
      Left            =   330
      TabIndex        =   2
      Top             =   900
      Width           =   2295
   End
   Begin VB.Label lblUI 
      Height          =   375
      Left            =   330
      TabIndex        =   6
      Top             =   1590
      UseMnemonic     =   0   'False
      Width           =   5415
   End
   Begin VB.Label Label1 
      Caption         =   "Search Criteria:"
      Height          =   315
      Left            =   330
      TabIndex        =   0
      Top             =   540
      Width           =   1245
   End
End
Attribute VB_Name = "Interface"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Dim m_MJEmulation       As New clsMJAutomation
Dim m_MJ                As Object

Public Sub Init(ByVal MediaJukebox As Object)
Dim MJVersion           As Object

    On Error Resume Next
    
    '  Store the main MJ reference
    Set m_MJ = MediaJukebox
    
    '  If is nothing then we are running under the IDE
    If m_MJ Is Nothing Then
    
        '  Point to our emulation class
        Set m_MJ = m_MJEmulation
        
    End If
    
    '  Point to the UI indicator
    Set m_MJEmulation.m_lblUI = lblUI
    
    '  Get the version
    Set MJVersion = m_MJ.GetVersion
    lblUI.Caption = "MJ Version: " & MJVersion.Version

End Sub

Public Sub Terminate()

    '  Kill all the objects
    Set m_MJEmulation = Nothing
    Set m_MJ = Nothing

End Sub

Private Sub btnDumpToFile_Click()

    '  Change the mouse
    Screen.MousePointer = vbHourglass
    
    '  Start dumping
    m_MJEmulation.EmulationDump m_MJ, txtCriteria.Text, IIf(chkExcludeSlowItems.Value, True, False)

    '  Change the mouse
    Screen.MousePointer = vbDefault
    
End Sub

Private Sub btnDumpToScreen_Click()
Dim m_MJFiles           As Object
Dim m_MJFile            As Object
Dim lLoop1              As Long

    '  Init the lbx
    lbxDump.Clear
    
    '  Perform the search
    Set m_MJFiles = m_MJ.Search(vbNullString)
    
    '  Dump the entries
    For lLoop1 = 0 To m_MJFiles.GetNumberFiles - 1
    
        '  Get the entry
        Set m_MJFile = m_MJFiles.GetFile(lLoop1)
        
        '  Update the UI
        lblUI.Caption = CStr(lLoop1 + 1) & " of " & m_MJFiles.GetNumberFiles
        lblUI.Refresh
        
        '  Add to the listbox
        lbxDump.AddItem m_MJFile.Artist & "," & m_MJFile.Album & "," & m_MJFile.Name
        
    Next
    
End Sub

Private Sub UserControl_Initialize()

    On Error Resume Next
    
    '  Disable the stuff we don't want when called from the IDE
    If tools_InIDE Then
        txtCriteria.Enabled = False
        chkExcludeSlowItems.Enabled = False
        btnDumpToFile.Enabled = False
    End If
    
End Sub


Public Function tools_InIDE() As Boolean
    Err.Clear
    On Error GoTo EndOfFunction
    Debug.Print 1 / 0
EndOfFunction:
    tools_InIDE = Err.Number
End Function

